library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity agosto7 is
port(clk,reset,enable,din:in std_logic;
     out_h,out_l: out std_logic_vector(3 downto 0));
end agosto7;

architecture Behavioral of agosto7 is
signal cnt: integer:=0;
signal reg: std_logic_vector(15 downto 0):="0000000000000000";
signal reg1: std_logic_vector(7 downto 0):="00000000";
signal outh: std_logic_vector(3 downto 0);
signal outl: std_logic_vector(3 downto 0);
begin
process(clk,reset,enable)
begin
if rising_edge(clk) then
if enable='1' then
if reset='1' then						  
if cnt>=0 and cnt<=15 then
reg<=reg(14 downto 0)&din;
cnt<=cnt+1;
elsif cnt=16 then
reg1<=reg(15)&reg(13)&reg(11)&reg(9)&reg(7)&reg(5)&reg(3)&reg(1);
cnt<=cnt+1;
elsif cnt=17 then
if reg1="01001110" then
outh<=reg(14)&reg(12)&reg(10)&reg(8);
outl<=reg(14)&reg(12)&reg(10)&reg(8)+reg1(3 downto 0);
cnt<=cnt+1;
else
outh<="ZZZZ";
outl<="ZZZZ";
cnt<=cnt+1;
end if;
elsif cnt=18 then
reg<="0000000000000000";
reg1<="00000000";
cnt<=0;
end if;
else--reset=0
outh<="XXXX";
outl<="XXXX";
cnt<=0;
end if;
else--enable=0
outh<="ZZZZ";
outl<="ZZZZ";
cnt<=0;
end if;
end if;
end process;
out_h<=outh;
out_l<=outl;
end Behavioral;
